package com.glxp.api.admin.service.inventory.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.inventory.InvProductDetailDao;
import com.glxp.api.admin.entity.inventory.InvProductDetailEntity;
import com.glxp.api.admin.req.inventory.FilterInvProductDetailRequest;
import com.glxp.api.admin.service.inventory.InvProductDetailService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;


@Service
public class InvProductDetailServiceImpl implements InvProductDetailService {

    @Resource
    InvProductDetailDao invProductDetailDao;

    @Override
    public List<InvProductDetailEntity> filterInvProduct(FilterInvProductDetailRequest filterInvProductDetailRequest) {
        if (filterInvProductDetailRequest == null) {
            return Collections.emptyList();
        }
        if (filterInvProductDetailRequest.getPage() != null) {
            int offset = (filterInvProductDetailRequest.getPage() - 1) * filterInvProductDetailRequest.getLimit();
            PageHelper.offsetPage(offset, filterInvProductDetailRequest.getLimit());
        }
        List<InvProductDetailEntity> data = invProductDetailDao.filterInvProductDetail(filterInvProductDetailRequest);
        return data;
    }

    @Override
    public boolean insertInvProduct(InvProductDetailEntity invProductDetailEntity) {
        return invProductDetailDao.insertInvProductDetail(invProductDetailEntity);
    }

    @Override
    public boolean insertInvProducts(List<InvProductDetailEntity> invProductDetailEntitys) {
        return invProductDetailDao.insertInvProductDetails(invProductDetailEntitys);
    }

    @Override
    public boolean updateInvProduct(InvProductDetailEntity invProductDetailEntity) {
        return invProductDetailDao.updateInvProductDetail(invProductDetailEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return invProductDetailDao.deleteById(id);
    }

    @Override
    public boolean deleteByProductId(String productIdFk) {
        return false;
    }
}
