package com.glxp.api.admin.thread;

import com.glxp.api.admin.constant.ConstantStatus;
import com.glxp.api.admin.constant.ConstantType;
import com.glxp.api.admin.entity.basic.BussinessTypeEntity;
import com.glxp.api.admin.entity.basic.UdiInfoEntity;
import com.glxp.api.admin.entity.inout.ErpOrderEntity;
import com.glxp.api.admin.entity.inout.FilterErpOrderRequest;
import com.glxp.api.admin.entity.inout.OrderEntity;
import com.glxp.api.admin.entity.inout.WarehouseEntity;
import com.glxp.api.admin.entity.inventory.InvProductDetailEntity;
import com.glxp.api.admin.entity.inventory.InvProductEntity;
import com.glxp.api.admin.req.basic.FilterUdiInfoRequest;
import com.glxp.api.admin.res.basic.UdiRelevanceResponse;
import com.glxp.api.admin.service.basic.BussinessTypeService;
import com.glxp.api.admin.service.basic.UdiInfoService;
import com.glxp.api.admin.service.basic.UdiRelevanceService;
import com.glxp.api.admin.service.inout.CodesService;
import com.glxp.api.admin.service.inout.OrderDetailService;
import com.glxp.api.admin.service.inout.OrderService;
import com.glxp.api.admin.service.inventory.InvProductDetailService;
import com.glxp.api.admin.service.inventory.InvProductService;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

@Service
public class InvProductsTrService {


    @Resource
    private OrderService orderService;
    @Resource
    private OrderDetailService myErpOrderService;
    @Resource
    private CodesService codesService;
    @Resource
    private UdiRelevanceService udiRelevanceService;
    @Resource
    private UdiInfoService udiInfoService;
    @Resource
    private BussinessTypeService bussinessTypeService;

    @Resource
    private InvProductService invProductService;
    @Resource
    private InvProductDetailService invProductDetailService;


    @Async
    public void genInvProducts(String orderId) {
        OrderEntity orderEntity = orderService.findById(orderId);
        if (orderEntity.getStatus() == ConstantStatus.ORDER_STATUS_SUCCESS &&
                (orderEntity.getContrastStatus() == ConstantStatus.ORDER_CHECK_SUCCESS ||
                        orderEntity.getContrastStatus() == ConstantStatus.ORDER_CHECK_UN)) {
            FilterErpOrderRequest filterErpOrderRequest = new FilterErpOrderRequest();
            filterErpOrderRequest.setOrderId(orderId);
            List<ErpOrderEntity> erpOrderEntities = myErpOrderService.filterAllMyErpOrder(filterErpOrderRequest);
            BussinessTypeEntity bussinessTypeEntity = bussinessTypeService.findBTByAction(orderEntity.getAction());
            if (erpOrderEntities != null && erpOrderEntities.size() > 0) {
                for (ErpOrderEntity erpOrderEntity : erpOrderEntities) {

                    String nameCode = erpOrderEntity.getNameCode();
                    String erpId = erpOrderEntity.getGoodsid();
                    FilterUdiInfoRequest filterUdiInfoRequest = new FilterUdiInfoRequest();
                    filterUdiInfoRequest.setNameCode(nameCode);
                    if (bussinessTypeEntity.getThirdSysFk() != null) {
                        if (bussinessTypeEntity.getThirdSysFk().equals("thirdId")) {
                            filterUdiInfoRequest.setThirdId(erpId);
                        } else if (bussinessTypeEntity.getThirdSysFk().equals("thirdId1")) {
                            filterUdiInfoRequest.setThirdId1(erpId);
                        } else if (bussinessTypeEntity.getThirdSysFk().equals("thirdId2")) {
                            filterUdiInfoRequest.setThirdId2(erpId);
                        } else if (bussinessTypeEntity.getThirdSysFk().equals("thirdId3")) {
                            filterUdiInfoRequest.setThirdId3(erpId);
                        } else if (bussinessTypeEntity.getThirdSysFk().equals("thirdId4")) {
                            filterUdiInfoRequest.setThirdId4(erpId);
                        }

                    }


                    List<UdiRelevanceResponse> udiRelevanceResponses = udiRelevanceService.filterUdiRelevance(filterUdiInfoRequest);
                    String relId = null;
                    if (udiRelevanceResponses != null && udiRelevanceResponses.size() > 0) {
                        relId = udiRelevanceResponses.get(0).getId() + "";
                    }
                    if (relId != null) {
                        InvProductEntity invProductEntity = invProductService.selectByUuid(relId, erpOrderEntity.getBatchNo());
                        if (invProductEntity == null) {
                            invProductEntity = new InvProductEntity();
                            invProductEntity.setRelIdFk(relId);
                            invProductEntity.setBatchNo(erpOrderEntity.getBatchNo());
                            invProductEntity.setExpireDate(erpOrderEntity.getExpireDate());
                            invProductEntity.setProductionDate(erpOrderEntity.getProductDate());
                            invProductEntity.setGgxh(erpOrderEntity.getPackSpec());
                            invProductEntity.setNameCode(erpOrderEntity.getNameCode());
                            invProductEntity.setProductsName(erpOrderEntity.getCoName());
                            invProductEntity.setYlqxzcrbarmc(erpOrderEntity.getProductCompany());
                            invProductEntity.setZczbhhzbapzbh(erpOrderEntity.getAuthCode());
                            if (orderEntity.getMainAction().equals(ConstantType.TYPE_OUT)) {
                                invProductEntity.setOutCount(erpOrderEntity.getCount());
                            } else if (orderEntity.getMainAction().equals(ConstantType.TYPE_PUT)) {
                                invProductEntity.setInCount(erpOrderEntity.getCount());
                            }
                            invProductService.insertInvProduct(invProductEntity);
                            invProductEntity = invProductService.selectByUuid(relId, erpOrderEntity.getBatchNo());
                        } else {
                            if (orderEntity.getMainAction().equals(ConstantType.TYPE_OUT)) {
                                invProductEntity.setOutCount(invProductEntity.getOutCount() + erpOrderEntity.getCount());
                            } else if (orderEntity.getMainAction().equals(ConstantType.TYPE_PUT)) {
                                invProductEntity.setInCount(invProductEntity.getInCount() + erpOrderEntity.getCount());
                            }
                            invProductService.updateInvProduct(invProductEntity);
                        }
                        List<WarehouseEntity> warehouseEntities = codesService.findByReceiptId(orderId);
                        if (warehouseEntities != null && warehouseEntities.size() > 0) {
                            for (WarehouseEntity warehouseEntity : warehouseEntities) {
                                UdiInfoEntity udiInfoEntity = udiInfoService.findByNameCode(warehouseEntity.getNameCode());
                                if (udiInfoEntity.getUuid().equals(erpOrderEntity.getUuidFk())) {
                                    if ((warehouseEntity.getBatchNo() == null && erpOrderEntity.getBatchNo() == null) ||
                                            warehouseEntity.getBatchNo().equals(erpOrderEntity.getBatchNo())) {
                                        InvProductDetailEntity invProductDetailEntity = new InvProductDetailEntity();
                                        invProductDetailEntity.setProductIdFk(invProductEntity.getId() + "");
                                        invProductDetailEntity.setCode(warehouseEntity.getCode());
                                        invProductDetailEntity.setAction(warehouseEntity.getAction());
                                        invProductDetailEntity.setMainAction(warehouseEntity.getMainAction());
                                        invProductDetailEntity.setOrderIdFk(warehouseEntity.getOrderId());
                                        invProductDetailEntity.setCount(warehouseEntity.getCount());
                                        invProductDetailEntity.setUpdateTime(new Date());
                                        invProductDetailService.insertInvProduct(invProductDetailEntity);
                                    }
                                }
                            }

                        }
                    }
                }
            }
        }

    }
}